#include <Wire.h>
#define LED 11
#define FIFOSize 100

void setup()
{
 pinMode(LED, OUTPUT);
 Wire.begin(0x04);                // join i2c bus with address #4 - or 8 for NXT
 Wire.onReceive(receiveEvent); // register event
 Serial.begin(9600);           // start serial for output
//  Serial.print("Starting MIDI");
}

int Buffer=0,chord=0;
int FIFO [FIFOSize][3];
int load=0, play=0;

void loop()
{
 if (Buffer > 0){
 digitalWrite(LED, HIGH);   // set the LED on
 sendMIDICommand();
 digitalWrite(LED, LOW);    // set the LED off
 }
 delay(1);
}

// function that executes whenever data is received from master
void receiveEvent(int howMany)
{
 if (howMany > 2)
 {
   Buffer ++;
 }
}

void sendMIDICommand()
 {
   uint8_t channel=0,command=0,note=65,velocity=100;
   uint16_t pitchbend=0;

   FIFO[load][0] = 0xFF & Wire.read(); // receive byte as a character
   FIFO[load][1] = 0x7F & Wire.read(); // receive byte as a character
   FIFO[load][2] = 0x7F & Wire.read(); // receive byte as a character
   load = (load + 1) % FIFOSize;

   command= 0xF0 & FIFO[play][0];
   channel= 0x0F & FIFO[play][0];
   note = FIFO[play][1];
   velocity = FIFO[play][2];
   pitchbend = (uint16_t)velocity * 128 + note;
   play = (play + 1) % FIFOSize;
   Buffer --;

   switch (command)
   {
     case 0x80:
//        Serial.print("note-off ");
         usbMIDI.sendNoteOff(note, velocity, channel);
         chord = chord - 1;
       break;
     case 0x90:
//        Serial.print("note-on ");
          usbMIDI.sendNoteOn(note, velocity, channel);
          chord = chord + 1;
       break;
     case 0xA0:
//        Serial.print("Key pressure ");     Serial.println (velocity);
           usbMIDI.sendPolyPressure(note, velocity, channel);  //(note, pressure, channel);
       break;
     case 0xB0:
//        Serial.print("control change "); Serial.println (velocity);
         usbMIDI.sendControlChange(note, velocity, channel);  //(control, value, channel);
       break;
     case 0xC0:
//        Serial.print("program change ");  Serial.println (note);
         usbMIDI.sendProgramChange(note, channel);   //(program, channel);
       break;
     case 0xD0:
//        Serial.print("Channel change ");
//          this is not defined usbMIDI.sendChannelChange(program, channel);    not using usbMIDI.sendAfterTouch(pressure, channel)
       break;
     case 0xE0:
//        Serial.print("pitch bend ");  Serial.println (note);
           usbMIDI.sendPitchBend(pitchbend, channel);  //(value, channel);
       break;
 //     case 0xF0:
//        Serial.print("system ex ");
 //           usbMIDI.sendSysEx(length, array);
 //       break;
     default:
       break;
   }
 }
